{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit TypeInfo;
{ |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* Ԫƣڽűʹõ TypInfo Ԫ
* Ԫߣܾ (zjy@cnpack.org)
*     עԪ޸ Borland Delphi Դ룬
*           Ԫͺͺ PasScript űʹ
* ƽ̨PWinXP SP2 + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7
*   
* ޸ļ¼2006.12.11 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

type
  TTypeKind = (tkUnknown, tkInteger, tkChar, tkEnumeration, tkFloat,
    tkString, tkSet, tkClass, tkMethod, tkWChar, tkLString, tkWString,
    tkVariant, tkArray, tkRecord, tkInterface, tkInt64, tkDynArray);

  TTypeKinds = set of TTypeKind;

  PTypeInfo = Pointer;

const
  tkAny = [Low(TTypeKind)..High(TTypeKind)];
  tkMethods = [tkMethod];
  tkProperties = tkAny - tkMethods - [tkUnknown];

function GetPropList(Instance: TObject; TypeKinds: TTypeKinds; PropList: TStrings): Integer;

function GetPropTypeInfo(Instance: TObject; const PropName: string): PTypeInfo;

function GetEnumName(TypeInfo: PTypeInfo; Value: Integer): string;

function GetEnumValue(TypeInfo: PTypeInfo; const Name: string): Integer;

function IsPublishedProp(Instance: TObject; const PropName: string): Boolean;

function PropIsType(Instance: TObject; const PropName: string; TypeKind: TTypeKind): Boolean;

function PropType(Instance: TObject; const PropName: string): TTypeKind;

function IsStoredProp(Instance: TObject; const PropName: string): Boolean;

function GetOrdProp(Instance: TObject; const PropName: string): Longint;

procedure SetOrdProp(Instance: TObject; const PropName: string; Value: Longint);

function GetEnumProp(Instance: TObject; const PropName: string): string;

procedure SetEnumProp(Instance: TObject; const PropName: string; const Value: string);

function GetSetProp(Instance: TObject; const PropName: string; Brackets: Boolean): string;

procedure SetSetProp(Instance: TObject; const PropName: string; const Value: string);

function GetObjectProp(Instance: TObject; const PropName: string): TObject;

procedure SetObjectProp(Instance: TObject; const PropName: string; Value: TObject);

function GetStrProp(Instance: TObject; const PropName: string): string;

procedure SetStrProp(Instance: TObject; const PropName: string; const Value: string);

function GetFloatProp(Instance: TObject; const PropName: string): Extended;

procedure SetFloatProp(Instance: TObject; const PropName: string; Value: Extended);

function GetVariantProp(Instance: TObject; const PropName: string): Variant;

procedure SetVariantProp(Instance: TObject; const PropName: string; const Value: Variant);

function GetMethodProp(Instance: TObject; const PropName: string): TMethod;

procedure SetMethodProp(Instance: TObject; const PropName: string; const Value: TMethod);

function GetInt64Prop(Instance: TObject; const PropName: string): Int64;

procedure SetInt64Prop(Instance: TObject; const PropName: string; const Value: Int64);

function GetPropValue(Instance: TObject; const PropName: string; PreferStrings: Boolean): Variant;

procedure SetPropValue(Instance: TObject; const PropName: string; const Value: Variant);

implementation

end.

