{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnWizShortCut;
{* |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* ԪƣIDE ݼ͹ʵֵԪ
* Ԫߣܾ (zjy@cnpack.org)
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   õԪеַϱػʽ
* ޸ļ¼2017.05.18 V1.0
*               Ԫʵֹ
================================================================================
|</PRE>}

interface

uses
  Windows, Messages, Classes, SysUtils, Menus, ExtCtrls, ToolsAPI,
  CnWizConsts, CnCommon;

type
//==============================================================================
// IDE ݼ
//==============================================================================

{ TCnWizShortCut }

  TCnWizShortCutMgr = class;

  TCnWizShortCut = class(TObject)
  {* IDE ݼ࣬ CnWizards ʹã˿ݼԺ͹ܡ
     ÿһĿݼʵԶڴʱעؿݼͷʱ
     б档벻ҪֱӴͷŸʵӦʹÿݼ
     WizShortCutMgr  Add  Delete ʵ֡}
  private
    FDefShortCut: TShortCut;
    FOwner: TCnWizShortCutMgr;
    FShortCut: TShortCut;
    FKeyProc: TNotifyEvent;
    FMenuName: string;
    FName: string;
    FTag: Integer;
    procedure SetKeyProc(const Value: TNotifyEvent);
    procedure SetShortCut(const Value: TShortCut);
    procedure SetMenuName(const Value: string);
    function ReadShortCut(const Name: string; DefShortCut: TShortCut): TShortCut;
    procedure WriteShortCut(const Name: string; AShortCut: TShortCut);
  protected
    procedure Changed; virtual;
  public
    constructor Create(AOwner: TCnWizShortCutMgr; const AName: string;
      AShortCut: TShortCut; AKeyProc: TNotifyEvent; const AMenuName: string;
      ATag: Integer = 0);
    {* ๹벻Ҫֱӵø÷ʵӦÿݼ
       WizShortCutMgr.Add  Delete ɾ}
    destructor Destroy; override;
    {* 벻ҪֱͷŸʵӦÿݼ
       WizShortCutMgr.Delete ɾһ IDE ݼ}

    property Name: string read FName;
    {* ݼ֣ͬʱҲǱעеļֵΪգÿݼ
       עС}
    property ShortCut: TShortCut read FShortCut write SetShortCut;
    {* ݼֵ}
    property KeyProc: TNotifyEvent read FKeyProc write SetKeyProc;
    {* ݼ֪ͨ¼ݼʱø¼}
    property MenuName: string read FMenuName write SetMenuName;
    {* ݼ IDE ˵}
    property Tag: Integer read FTag write FTag;
    {* ݼǩ}
  end;

//==============================================================================
// IDE ݼ󶨽ӿʵ
//==============================================================================

{ TCnKeyBinding }

  TCnKeyBinding = class(TNotifierObject, IOTAKeyboardBinding)
  {* IDE ݼ󶨽ӿʵ࣬ CnWizards ڲʹá
     ʵ IOTAKeyboardBinding ӿڣɱ IDE Զ IDE Ŀݼ󶨡
      IDE ݼ TCnWizShortCutMgr ڲʹã벻Ҫֱʹá}
  private
    FOwner: TCnWizShortCutMgr;
  protected
    procedure KeyProc(const Context: IOTAKeyContext; KeyCode: TShortcut;
      var BindingResult: TKeyBindingResult);
    property Owner: TCnWizShortCutMgr read FOwner;
  public
    constructor Create(AOwner: TCnWizShortCutMgr);
    {* ๹ IDE ݼΪ}
    destructor Destroy; override;

    // IOTAKeyboardBinding methods
    function GetBindingType: TBindingType;
    {* ȡͣʵֵ IOTAKeyboardBinding }
    function GetDisplayName: string;
    {* ȡݼʾƣʵֵ IOTAKeyboardBinding }
    function GetName: string;
    {* ȡݼƣʵֵ IOTAKeyboardBinding }
    procedure BindKeyboard(const BindingServices: IOTAKeyBindingServices);
    {* ݼ󶨹̣ʵֵ IOTAKeyboardBinding }
  end;

//==============================================================================
// IDE ݼ
//==============================================================================

{ TCnWizShortCutMgr }

  TCnWizShortCutMgr = class(TObject)
  {* IDE ݼ࣬ά IDE а󶨵Ŀݼб
     벻ҪֱӴʵӦʹ WizShortCutMgr õǰĹʵ}
  private
    FShortCuts: TList;
    FKeyBindingIndex: Integer;
    FUpdateCount: Integer;
    FUpdated: Boolean;
    FSaveMenus: TList;
    FSaveShortCuts: TList;
    FMenuTimer: TTimer;
    function GetShortCuts(Index: Integer): TCnWizShortCut;
    function GetCount: Integer;
    procedure InstallKeyBinding;
    procedure RemoveKeyBinding;
    procedure SaveMainMenuShortCuts;
    procedure RestoreMainMenuShortCuts;
    procedure DoRestoreMainMenuShortCuts(Sender: TObject);
  public
    constructor Create;
    {* ๹벻ҪֱӴʵӦʹ WizShortCutMgr õǰ
       Ĺʵ}
    destructor Destroy; override;
    {* }
    function IndexOfShortCut(AWizShortCut: TCnWizShortCut): Integer;
    {*  IDE ݼţΪݼڷ-1}
    function IndexOfName(const AName: string): Integer; 
    {* ݿݼƲţڷ-1}
    function Add(const AName: string; AShortCut: TShortCut; AKeyProc:
      TNotifyEvent; const AMenuName: string = ''; ATag: Integer = 0): TCnWizShortCut;
    {* һݼ
     |<PRE>
       AName: string           - ݼƣΪմÿݼ浽ע
       AShortCut: TShortCut    - ݼĬϼֵ AName ЧʵʹõļֵǴעжȡ
       AKeyProc: TNotifyEvent  - ݼ֪ͨ¼
       AMenuName: string       - ݼӦ IDE ˵ûпΪ
       Result: Integer;        - ӵĿݼţҪĿݼѴڷ-1
     |</PRE>}
    procedure Delete(Index: Integer);
    {* ɾһݼ󣬲Ϊݼš}
    procedure DeleteShortCut(var AWizShortCut: TCnWizShortCut); 
    {* ɾһݼ󣬲Ϊݼ󣬵óɹΪ nil}
    procedure Clear;
    {* տݼб}
    procedure BeginUpdate;
    {* ʼ¿ݼбڴ֮ԿݼбĸĶԶаˢ£
       ֻе½ŻԶ°󶨡
       ʹʱ EndUpdate ԡ}
    procedure EndUpdate;
    {* Կݼбĸ£һεãԶ° IDE ݼ
       ʹʱ BeginUpdate ԡ}
    function Updating: Boolean;
    {* ݼб״̬ BeginUpdate  EndUpdate}
    procedure UpdateBinding;
    {* Ѱ󶨵Ŀݼб}

    property Count: Integer read GetCount;
    {* ݼ}
    property ShortCuts[Index: Integer]: TCnWizShortCut read GetShortCuts;
    {* ݼ}
  end;

function WizShortCutMgr: TCnWizShortCutMgr;
{* صǰ IDE ݼʵҪʹÿݼ벻ҪֱӴ
   TCnWizShortCutMgr ʵӦøúʡ}

implementation

{ TCnWizShortCut }

procedure TCnWizShortCut.Changed;
begin

end;

constructor TCnWizShortCut.Create(AOwner: TCnWizShortCutMgr;
  const AName: string; AShortCut: TShortCut; AKeyProc: TNotifyEvent;
  const AMenuName: string; ATag: Integer);
begin

end;

destructor TCnWizShortCut.Destroy;
begin
  inherited;

end;

function TCnWizShortCut.ReadShortCut(const Name: string;
  DefShortCut: TShortCut): TShortCut;
begin

end;

procedure TCnWizShortCut.SetKeyProc(const Value: TNotifyEvent);
begin

end;

procedure TCnWizShortCut.SetMenuName(const Value: string);
begin

end;

procedure TCnWizShortCut.SetShortCut(const Value: TShortCut);
begin

end;

procedure TCnWizShortCut.WriteShortCut(const Name: string;
  AShortCut: TShortCut);
begin

end;

{ TCnWizShortCutMgr }

function TCnWizShortCutMgr.Add(const AName: string; AShortCut: TShortCut;
  AKeyProc: TNotifyEvent; const AMenuName: string;
  ATag: Integer): TCnWizShortCut;
begin

end;

procedure TCnWizShortCutMgr.BeginUpdate;
begin

end;

procedure TCnWizShortCutMgr.Clear;
begin

end;

constructor TCnWizShortCutMgr.Create;
begin

end;

procedure TCnWizShortCutMgr.Delete(Index: Integer);
begin

end;

procedure TCnWizShortCutMgr.DeleteShortCut(
  var AWizShortCut: TCnWizShortCut);
begin

end;

destructor TCnWizShortCutMgr.Destroy;
begin
  inherited;

end;

procedure TCnWizShortCutMgr.DoRestoreMainMenuShortCuts(Sender: TObject);
begin

end;

procedure TCnWizShortCutMgr.EndUpdate;
begin

end;

function TCnWizShortCutMgr.GetCount: Integer;
begin

end;

function TCnWizShortCutMgr.GetShortCuts(Index: Integer): TCnWizShortCut;
begin

end;

function TCnWizShortCutMgr.IndexOfName(const AName: string): Integer;
begin

end;

function TCnWizShortCutMgr.IndexOfShortCut(
  AWizShortCut: TCnWizShortCut): Integer;
begin

end;

procedure TCnWizShortCutMgr.InstallKeyBinding;
begin

end;

procedure TCnWizShortCutMgr.RemoveKeyBinding;
begin

end;

procedure TCnWizShortCutMgr.RestoreMainMenuShortCuts;
begin

end;

procedure TCnWizShortCutMgr.SaveMainMenuShortCuts;
begin

end;

procedure TCnWizShortCutMgr.UpdateBinding;
begin

end;

function TCnWizShortCutMgr.Updating: Boolean;
begin

end;

function WizShortCutMgr: TCnWizShortCutMgr;
begin

end;

{ TCnKeyBinding }

procedure TCnKeyBinding.BindKeyboard(
  const BindingServices: IOTAKeyBindingServices);
begin

end;

constructor TCnKeyBinding.Create(AOwner: TCnWizShortCutMgr);
begin

end;

destructor TCnKeyBinding.Destroy;
begin
  inherited;

end;

function TCnKeyBinding.GetBindingType: TBindingType;
begin

end;

function TCnKeyBinding.GetDisplayName: string;
begin

end;

function TCnKeyBinding.GetName: string;
begin

end;

procedure TCnKeyBinding.KeyProc(const Context: IOTAKeyContext;
  KeyCode: TShortcut; var BindingResult: TKeyBindingResult);
begin

end;

end.
